/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Main menu functions and commands                                       *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>

#ifdef OS_2
#define INCL_NOPM
#define INCL_DOSDEVICES
#include <os2.h>
#if !defined(CALLBACK)
#include "os2fubar.h"
#endif  /* CALLBACK */
#endif  /* OS_2 */

#include "prog.h"
#include "ffind.h"
#include "alc.h"
#include "max.h"


void pascal Yell(void)
{
  char temp[PATHLEN];

  int x,y,
      doyell;

  time_t gmtime;
  struct tm *ts;

  if (local)
  {
    Puts(err999_1);
    OpusGets(temp,err999_2);
  }
  else
  {
    chatreq=TRUE;

    logit(s(log_user_yelling),usr.name);

    gmtime=time(NULL);
    ts=localtime(&gmtime);

    doyell=FALSE;

    for (x=0;x < MAX_YELL;x++)
    {
      if (ts->tm_wday==prm.yell[x].weekday || prm.yell[x].weekday==7)
      {
        if (ts->tm_hour >= prm.yell[x].start_hour && ts->tm_hour <= prm.yell[x].end_hour)
        {
          if (ts->tm_hour==prm.yell[x].start_hour && ts->tm_hour==prm.yell[x].end_hour)
          {
            if (ts->tm_min >= prm.yell[x].start_min && ts->tm_min < prm.yell[x].end_min)
              doyell=TRUE;
          }
          else if (ts->tm_hour==prm.yell[x].start_hour)
          {
            if (ts->tm_min >= prm.yell[x].start_min)
              doyell=TRUE;
          }
          else if (ts->tm_hour==prm.yell[x].end_hour)
          {
            if (ts->tm_min <= prm.yell[x].end_min)
              doyell=TRUE;
          }
          else doyell=TRUE;
        }
      }

      if (doyell)
        break;
    }

    if (doyell)
    {
      Printf(s(user_yelling),usr.name);

      for (y=0;y < prm.yell[x].bells;y++)
      {
        if (kbhit() || mdm_avail())
          break;

        Mdm_putc('\x07');

        Delay(85);

        if (prm.noise_ok)
          Local_Beep(1);
      }

      if (Mdm_keyp())
        Mdm_getcw();

      /* If Sysop didn't press <sp>, and didn't press 'C' (which sets      *
       * chatreq to FALSE)                                                 */

      if (!kbhit() && chatreq)  
      {
        sprintf(temp,"%sNOTIN.?BS",original_path);

        if (fexist(temp))
        {
          *strrchr(temp,'.')='\0';
          Display_File(0,NULL,temp);
        }
        else
        {
          Puts(s(il_nest_pas_ici));
          Press_ENTER();
        }
      }
    }
    else
    {
      sprintf(temp,"%sYELL.?BS",original_path);

      if (fexist(temp))
      {
        *strrchr(temp,'.')='\0';
        Display_File(0,NULL,temp);
      }
      else
      {
        Puts(s(yell_is_off));
        Press_ENTER();
      }
    }
  }
}


#ifndef __TURBOC__
#define peekb(seg, off)  *((char far *)((unsigned long)seg<<16L | off))
#endif


void pascal Version(void)
{
  unsigned char id,
                subid;

  Puts(CLS);

  Printf(slogan,LMAGENTA,version,test);
  Puts(copyright);

#ifdef DMALLOC
  Printf(LGREEN "Remaining memory in heap: %05lu bytes\n\n",(long)coreleft());
  ptab();
  getch();
#endif

  /* Now tell user when we were compiled */

  Compilation_Data();

#ifdef OS_2
  DosDevConfig(&id,DEVINFO_MODEL,0);
  DosDevConfig(&subid,DEVINFO_SUBMODEL,0);
#else
  id=peekb(0xffffu,0x000e);
  subid=0;
#endif


  Puts(s(computer_type));

  switch (id)
  {
    case 0xff:
      Puts(s(class_pc));
      break;

    case 0xfe:
      Puts(s(class_xt));
      break;

    case 0xfd:
      Puts(s(class_pcjr));
      break;

    case 0xfc:
      switch(subid)
      {
        case 0x01:
          Puts(s(class_at339));
          break;

        case 0x02:
          Puts(s(class_ps2_xt));
          break;

        case 0x04:
          Puts(s(class_ps2_50));
          break;

        case 0x05:
          Puts(s(class_ps2_60));
          break;

        default:
          Puts(s(class_at));
          break;
      }
      break;

    case 0xfa:
      Puts(s(class_ps2_30));
      break;

    case 0xf9:
      Puts(s(class_pc_conv));
      break;

    case 0xf8:
      Puts(s(class_ps2_80));
      break;

    case 0x9a:
      Puts(s(class_compaq_p));
      break;

    case 0x2d:
      Puts(s(class_compaq));
      break;

    default:
      Printf(s(class_generic),(int)id);
      break;
  }

  if (subid)
    Printf(s(minor_revision),subid+1);
  else Putc('\n');

  Puts(s(oper_sys));

#ifdef OS_2
  Printf(s(os2_ver),_osmajor-9,_osminor);
#else

  {
    struct _fossil_info finfo;

    if (_osmajor > 9)
      Printf(s(os2_dosbox),_osmajor-9,_osminor);
    else Printf(s(dos_ver),_osmajor,_osminor);

    fossil_inf(&finfo);
    Printf(s(fossil_ver),finfo.id);
  }

#endif

  Printf(s(heap_mem),(long)coreleft());
}



void pascal Compilation_Data(void)
{
#if defined(__TURBOC__)
  #define COMPILER "Turbo C"
#elif defined(_QC)
  #define COMPILER "Microsoft Quick C"
#elif defined(__MSC__)
  #define COMPILER "Microsoft C"
#elif defined(__ZTC__)
  #define COMPILER "Zortech C"
#else
#error Unknown compiler type!
#endif


#if _MSC_VER > 0
  #define COMPSTR       " v%d.%d"
  #define COMPVERMAJ    _MSC_VER/100
  #define COMPVERMIN    _MSC_VER % 100
#elif defined(__TURBOC__)
  #define COMPSTR       " v%d.%d"
  #define COMPVERMAJ    __TURBOC__/0x100
  #define COMPVERMIN    __TURBOC__ % 0x100
#else
  #define COMPSTR
  #define COMPVERMAJ    0
  #define COMPVERMIN    0
#endif

  Printf(LBLUE "Compiled on %s at %s under " COMPILER COMPSTR "\n\n",
         comp_date,comp_time,COMPVERMAJ,COMPVERMIN);
}



int pascal UserList(void)
{
  char string[BUFLEN];

  int userbbs,
      found,
      ret;

  char nonstop;

  struct _usr user;

  ret=1;  /* Not found */

  WhiteN();

  if (usr.help==HOTFLASH)
    OpusGetsLL(string,BUFLEN,s(ul_all));
  else
  {
    if (isnl(linebuf))
      Puts(s(ul_1));

    OpusGetsLL(string,BUFLEN,s(ul_2));
  }

  if (isnl(linebuf))
    Putc('\n');

  if ((userbbs=shopen(PRM(user_file),O_RDONLY | O_BINARY))==-1)
  {
    logit(cantopen,PRM(user_file));
    quit(ERROR_file);
  }

  display_line=display_col=1;
  nonstop=FALSE;

  found=FALSE;

  while (! eof(userbbs))
  {
    if (mdm_halt() || brk_trapped)
    {
      brk_trapped=0;
      mdm_dump(DUMP_all);
      ret=-1;
      break;
    }

    read(userbbs,(char *)&user,sizeof(struct _usr));

    if (isnl(string) || stristr(user.name,string))
    {
      if (GEPriv(user.priv,prm.min_ulist) &&
          LEPriv(user.priv,prm.max_ulist) &&
          !(user.flag & UFLAG_deleted))
      {
        found=TRUE;

        ret=0;

        Printf(s(ul_format),user.name,
               35-strlen(user.name),user.ldate);

        if (MoreYnBreak(&nonstop,CYAN))
        {
          ret=-1;
          break;
        }
      }
    }
  }

  if (!found)
    Printf(s(ul_notfound),string);

  close(userbbs);
  return ret;
}



void pascal Statistics(void)
{
  char temp[PATHLEN];
  struct _stamp stamp;
  time_t ct;

  Printf(s(ustat1),Timestamp_Format(PRM(dateformat),
         TmDate_to_OpusDate(localtime(((ct=time(NULL)),&ct)),&stamp),temp));

  Printf("%s\n\n",Timestamp_Format(PRM(timeformat),&stamp,temp));

  Puts(s(ustat2));
  Printf(s(ustat3),timeonline());
  Printf(s(ustat4),timeleft());

  if (usr.time)
    Printf(s(ustat5),usr.time);

  Printf(s(ustat6),usr.times);

  Puts(s(ustat7));
  Printf(s(ustat8),usr.upld);
  Printf(s(ustat9),usr.dnld);

  if (usr.dnldl)
    Printf(s(ustat10),usr.dnldl);
  
  Printf(s(ustat10_5),prm.class[class].max_dl-usr.dnldl);

  if (usr.credit || usr.debit)
  {
    Puts(s(ustat11));
    Printf(s(ustat12),usr.credit);
    Printf(s(ustat13),usr.debit);
  }

  if (last_bps)
    Printf(s(ustat14),last_bps,
                 (last_bps*100)/baud);

  Puts("\n");
}
